(function (global, factory) {
    typeof exports === 'object' && typeof module !== 'undefined' ? factory(exports, require('@angular/core')) :
    typeof define === 'function' && define.amd ? define('@matej.cupka/ngx-markjs', ['exports', '@angular/core'], factory) :
    (global = global || self, factory((global.matej = global.matej || {}, global.matej.cupka = global.matej.cupka || {}, global.matej.cupka['ngx-markjs'] = {}), global.ng.core));
}(this, function (exports, core) { 'use strict';

    /**
     * @fileoverview added by tsickle
     * @suppress {checkTypes,constantProperty,extraRequire,missingOverride,missingReturn,unusedPrivateMembers,uselessCode} checked by tsc
     */
    /** @type {?} */
    var Mark = require('mark.js');
    /** @type {?} */
    var cancelAnimationId;
    /**
     * @param {?} __0
     * @return {?}
     */
    function animate(_a) {
        var timing = _a.timing, draw = _a.draw, duration = _a.duration;
        /** @type {?} */
        var start = performance.now();
        cancelAnimationId = requestAnimationFrame((/**
         * @param {?} time
         * @return {?}
         */
        function animate2(time) {
            // timeFraction goes from 0 to 1
            /** @type {?} */
            var timeFraction = (time - start) / duration;
            if (timeFraction > 1) {
                timeFraction = 1;
            }
            // calculate the current animation state
            /** @type {?} */
            var progress = timing(timeFraction);
            draw(progress); // draw it
            if (timeFraction < 1) {
                cancelAnimationId = requestAnimationFrame(animate2);
            }
        }));
    }
    var MarkjsHighlightDirective = /** @class */ (function () {
        function MarkjsHighlightDirective(contentElementRef, renderer) {
            this.contentElementRef = contentElementRef;
            this.renderer = renderer;
            this.markjsHighlight = '';
            this.markjsConfig = {};
            this.minimumMarkLength = 3;
            this.scrollToFirstMarked = false;
            this.getInstance = new core.EventEmitter();
        }
        /**
         * @param {?} changes
         * @return {?}
         */
        MarkjsHighlightDirective.prototype.ngOnChanges = /**
         * @param {?} changes
         * @return {?}
         */
        function (changes) {
            if (!this.markInstance) {
                this.markInstance = new Mark(this.contentElementRef.nativeElement);
                this.getInstance.emit(this.markInstance);
            }
            this.hightlightText();
            if (this.scrollToFirstMarked) {
                this.scrollToFirstMarkedText();
            }
        };
        /**
         * @return {?}
         */
        MarkjsHighlightDirective.prototype.hightlightText = /**
         * @return {?}
         */
        function () {
            var _this = this;
            this.markjsHighlight = this.markjsHighlight || '';
            if (this.markjsHighlight && this.markjsHighlight.length <= (this.minimumMarkLength - 1)) {
                this.markInstance.unmark();
                return;
            }
            else {
                this.markInstance.unmark({
                    done: (/**
                     * @return {?}
                     */
                    function () {
                        _this.markInstance.mark((_this.markjsHighlight || ''), _this.markjsConfig);
                    })
                });
            }
        };
        /**
         * @return {?}
         */
        MarkjsHighlightDirective.prototype.scrollToFirstMarkedText = /**
         * @return {?}
         */
        function () {
            /** @type {?} */
            var content = this.contentElementRef.nativeElement;
            /** @type {?} */
            var firstOffsetTop = (content.querySelector('mark') || {}).offsetTop || 0;
            this.scrollSmooth(content, firstOffsetTop);
        };
        /**
         * @param {?} scrollElement
         * @param {?} firstOffsetTop
         * @return {?}
         */
        MarkjsHighlightDirective.prototype.scrollSmooth = /**
         * @param {?} scrollElement
         * @param {?} firstOffsetTop
         * @return {?}
         */
        function (scrollElement, firstOffsetTop) {
            /** @type {?} */
            var renderer = this.renderer;
            if (cancelAnimationId) {
                cancelAnimationFrame(cancelAnimationId);
            }
            /** @type {?} */
            var currentScrollTop = scrollElement.scrollTop;
            /** @type {?} */
            var delta = firstOffsetTop - currentScrollTop;
            animate({
                duration: 500,
                timing: /**
                 * @param {?} timeFraction
                 * @return {?}
                 */
                function (timeFraction) {
                    return timeFraction;
                },
                draw: /**
                 * @param {?} progress
                 * @return {?}
                 */
                function (progress) {
                    /** @type {?} */
                    var nextStep = currentScrollTop + progress * delta;
                    renderer.setProperty(scrollElement, 'scrollTop', nextStep);
                }
            });
        };
        MarkjsHighlightDirective.decorators = [
            { type: core.Directive, args: [{
                        selector: '[markjsHighlight]'
                    },] }
        ];
        /** @nocollapse */
        MarkjsHighlightDirective.ctorParameters = function () { return [
            { type: core.ElementRef },
            { type: core.Renderer2 }
        ]; };
        MarkjsHighlightDirective.propDecorators = {
            markjsHighlight: [{ type: core.Input }],
            markjsConfig: [{ type: core.Input }],
            minimumMarkLength: [{ type: core.Input }],
            scrollToFirstMarked: [{ type: core.Input }],
            getInstance: [{ type: core.Output }]
        };
        return MarkjsHighlightDirective;
    }());
    if (false) {
        /** @type {?} */
        MarkjsHighlightDirective.prototype.markjsHighlight;
        /** @type {?} */
        MarkjsHighlightDirective.prototype.markjsConfig;
        /** @type {?} */
        MarkjsHighlightDirective.prototype.minimumMarkLength;
        /** @type {?} */
        MarkjsHighlightDirective.prototype.scrollToFirstMarked;
        /** @type {?} */
        MarkjsHighlightDirective.prototype.getInstance;
        /** @type {?} */
        MarkjsHighlightDirective.prototype.markInstance;
        /**
         * @type {?}
         * @private
         */
        MarkjsHighlightDirective.prototype.contentElementRef;
        /**
         * @type {?}
         * @private
         */
        MarkjsHighlightDirective.prototype.renderer;
    }

    /**
     * @fileoverview added by tsickle
     * @suppress {checkTypes,constantProperty,extraRequire,missingOverride,missingReturn,unusedPrivateMembers,uselessCode} checked by tsc
     */
    var NgxMarkjsModule = /** @class */ (function () {
        function NgxMarkjsModule() {
        }
        NgxMarkjsModule.decorators = [
            { type: core.NgModule, args: [{
                        declarations: [MarkjsHighlightDirective],
                        imports: [],
                        exports: [MarkjsHighlightDirective]
                    },] }
        ];
        return NgxMarkjsModule;
    }());

    exports.NgxMarkjsModule = NgxMarkjsModule;
    exports.ɵa = MarkjsHighlightDirective;

    Object.defineProperty(exports, '__esModule', { value: true });

}));
//# sourceMappingURL=matej.cupka-ngx-markjs.umd.js.map
